//softedge
J.fn.softedge = function(options){
	var image = J(this);
	var defaults = {
		step: 30,
		dirTop: false,
		dirBottom: false,
		dirRight: false,
		dirLeft: false,
		stepWidth: 15
	};
	J.extend(defaults, options);
	var w,h,t,l;
	
	function set(obj,i){
		var o = i;
		i *= defaults.stepWidth;
		dt = (defaults.dirTop) ? i : 0;
		dr = (defaults.dirRight) ? w-i : w;
		db = (defaults.dirBottom) ? h-i : h;
		dl = (defaults.dirLeft) ? i : 0;		
		obj.css({'position':'absolute', 'top':t+"px", 'left' : l+"px", 'clip' : "rect("+dt+"px,"+dr+"px,"+db+"px,"+dl+"px)"});
		setOpacity(obj,((o*100)/defaults.step));
	}
	
	function setOpacity(obj,o){
		if (o > 100) o = 100;
		if (o < 0) o = 0;
		obj.css({'opacity':(o/100)});
		obj.css({'MozOpacity':(o/100)});
		obj.css({'KhtmlOpacity':(o/100)});
		obj.css({'filter':"alpha(opacity="+ o +")"});
	}
	
	function init(){
		if(image.parent().attr('class') != 'softedge_container'){
			image.wrap('<span />');
			var parent = image.parent();
			parent.attr('class','softedge_container')
			parent.css({'position':'relative','display':'inline-block'})
			w = image.innerWidth();
			h = image.innerHeight();
			t = 0;
			l = 0;
			setOpacity(image,0);
			for (var j=1;j<defaults.step;j++){
				var edge = image.clone();
				set(edge,j);
				parent.append(edge);	
			};
		}
	}

	J(this).bind('load', function(){
		init();
	}).each(function(){
		if (this.complete || this.complete === undefined){
			init();
		} //needed for potential cached images
	});
}
//\softedge




J(document).ready(function() {

	J('.softedge_top').each(function(){
		J(this).softedge({
			dirTop: true
		});
	});

	J('.softedge_bottom').each(function(){
		J(this).softedge({
			dirBottom: true
		});
	});
	
	J('.softedge_right').each(function(){
		J(this).softedge({
			dirRight: true
		});
	});
	
	J('.softedge_left').each(function(){
		J(this).softedge({
			dirLeft: true
		});
	});

	J('.softedge_all').each(function(){
		J(this).softedge({
			dirTop: true,
			dirBottom: true,
			dirRight: true,
			dirLeft: true
		});
	});

});
