<?php
// ----------------------------------------------------------------------
// Copyright (C) 2007 by Khaled Al-Shamaa.
// http://www.al-shamaa.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is open source product; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Class Name: Spell numbers in the Arabic idiom
// Filename:   ArNumbers.class.php
// Original    Author(s): Khaled Al-Sham'aa <khaled.alshamaa@gmail.com>
// Purpose:    Spell numbers in the Arabic idiom
// ----------------------------------------------------------------------

class ArNumbers {

     var $individual = array();
     var $feminine = 1;
     var $format = 1;

     function ArNumbers(){
        $this->individual[1][1] = '';
        $this->individual[1][2] = '';

        $this->individual[2][1][1] = '';
        $this->individual[2][1][2] = '';
        $this->individual[2][2][1] = '';
        $this->individual[2][2][2] = '';

        $this->individual[3][1]  = '';
        $this->individual[4][1]  = '';
        $this->individual[5][1]  = '';
        $this->individual[6][1]  = '';
        $this->individual[7][1]  = '';
        $this->individual[8][1]  = '';
        $this->individual[9][1]  = '';
        $this->individual[10][1] = '';
        $this->individual[3][2]  = '';
        $this->individual[4][2]  = '';
        $this->individual[5][2]  = '';
        $this->individual[6][2]  = '';
        $this->individual[7][2]  = '';
        $this->individual[8][2]  = '';
        $this->individual[9][2]  = '';
        $this->individual[10][2] = '';

        $this->individual[11][1] = ' ';
        $this->individual[11][2] = ' ';

        $this->individual[12][1][1] = ' ';
        $this->individual[12][1][2] = ' ';
        $this->individual[12][2][1] = ' ';
        $this->individual[12][2][2] = ' ';

        $this->individual[13][1]  = ' ';
        $this->individual[14][1]  = ' ';
        $this->individual[15][1]  = ' ';
        $this->individual[16][1]  = ' ';
        $this->individual[17][1]  = ' ';
        $this->individual[18][1]  = ' ';
        $this->individual[19][1]  = ' ';
        $this->individual[13][2]  = ' ';
        $this->individual[14][2]  = ' ';
        $this->individual[15][2]  = ' ';
        $this->individual[16][2]  = ' ';
        $this->individual[17][2]  = ' ';
        $this->individual[18][2]  = ' ';
        $this->individual[19][2]  = ' ';

        $this->individual[20][1] = '';
        $this->individual[30][1] = '';
        $this->individual[40][1] = '';
        $this->individual[50][1] = '';
        $this->individual[60][1] = '';
        $this->individual[70][1] = '';
        $this->individual[80][1] = '';
        $this->individual[90][1] = '';
        $this->individual[20][2] = '';
        $this->individual[30][2] = '';
        $this->individual[40][2] = '';
        $this->individual[50][2] = '';
        $this->individual[60][2] = '';
        $this->individual[70][2] = '';
        $this->individual[80][2] = '';
        $this->individual[90][2] = '';

        $this->individual[200][1] = '';
        $this->individual[200][2] = '';

        $this->individual[100] = '';
        $this->individual[300] = '';
        $this->individual[400] = '';
        $this->individual[500] = '';
        $this->individual[600] = '';
        $this->individual[700] = '';
        $this->individual[800] = '';
        $this->individual[900] = '';

        $this->complications[1][1] = '';
        $this->complications[1][2] = '';
        $this->complications[1][3] = '';
        $this->complications[1][4] = '';

        $this->complications[2][1] = '';
        $this->complications[2][2] = '';
        $this->complications[2][3] = '';
        $this->complications[2][4] = '';

        $this->complications[3][1] = '';
        $this->complications[3][2] = '';
        $this->complications[3][3] = '';
        $this->complications[3][4] = '';
     }

      function setFeminine($value){
          $this->feminine = $value;
      }

      function setFormat($value){
          $this->format = $value;
      }

      function getFeminine(){
          return $this->feminine;
      }

      function getFormat(){
          return $this->format;
      }

      function int2str($number){
          $blocks = array();
          $items  = array();
          $string = '';

          while(strlen($number) > 3){
              array_push($blocks, substr($number, -3));
              $number = substr($number, 0, strlen($number)-3);
          }
          array_push($blocks, $number);

          $blocks_num = count($blocks);
          
          for($i=$blocks_num; $i>=0; $i--){
			if(isset($blocks[$i])){					//Bdr130_3 -> Undefined offset: 2
              $number = floor($blocks[$i]);
              $text = $this->written_block($number);
              if($text){
                 if($number == 1 && $i != 0){
                    $text = $this->complications[$i][4];
                 }elseif($number == 2 && $i != 0){
                    $text = $this->complications[$i][$this->format];
                 }elseif($number > 2 && $number < 11){
                    $text .= ' '.$this->complications[$i][3];
                 }else{
					if(isset($this->complications[$i][4])){				//Bdr130_3 -> Undefined offset: 0
						$text .= ' '.$this->complications[$i][4];
					}
                 }
                 array_push($items, $text);
              }
			 }
          }

          $string = implode('  ', $items);

          return $string;
      }

      function written_block($number){
          $items    = array();
          $string   = '';
          
          if($number > 99){
             $hundred = floor($number / 100) * 100;
             $number  = $number % 100;
      
             if($hundred == 200){
                array_push($items, $this->individual[$hundred][$this->format]);
             }else{
                array_push($items, $this->individual[$hundred]);
             }
          }
          
          if($number == 2 || $number == 12) {
             array_push($items, $this->individual[$number][$this->feminine][$this->format]);
          }elseif($number < 20) {
			if(isset($this->individual[$number][$this->feminine])){				//Bdr130_3 -> Undefined offset: 0
             array_push($items, $this->individual[$number][$this->feminine]);
			}
          }else{
             $ones = $number % 10;
             $tens = floor($number / 10) * 10;

             if($ones == 2){
                array_push($items, $this->individual[$ones][$this->feminine][$this->format]);
             }elseif($ones > 0){
                array_push($items, $this->individual[$ones][$this->feminine]);
             }

             array_push($items, $this->individual[$tens][$this->format]);
          }

          $items = array_diff($items, array(''));

          $string = implode('  ', $items);

          return $string;
      }

}
?>