function replaceAll(txt, replace, with_this) {
	return txt.replace(new RegExp(replace, 'g'), with_this);
}
function colorToHex(color) {
	if (color.substr(0, 1) === '#') {
		return color;
	}
	color = replaceAll(color, ' ', '');
	var digits = color.match(/(.*?)rgb\((\d+),(\d+),(\d+)\)/);

	var red = parseInt(digits[2]);
	var green = parseInt(digits[3]);
	var blue = parseInt(digits[4]);

	return "#" + ((1 << 24) + (red << 16) + (green << 8) + blue).toString(16).slice(1);
}

$(document).ready(function(){
	function render_style(){

		$('#poem').css('font-family',$('#font-family').val());
		$('#poem').css('font-size',(parseInt($('#font-size').val()))+'px');
		$('#poem').css('color',$('#font-color').val());
		if($('#toolbar .bold').length > 0){
			$('#poem').css('font-weight','normal');
		}
		if($('#toolbar .bold-active').length > 0){
			$('#poem').css('font-weight','bold');
		}
		if($('#toolbar .italic').length > 0){
			$('#poem').css('font-style','normal');
		}
		if($('#toolbar .italic-active').length > 0){
			$('#poem').css('font-style','italic');
		}
		if($('#toolbar .align-right-active').length > 0){
			$('#poem').css('text-align','right');
		}
		if($('#toolbar .align-center-active').length > 0){
			$('#poem').css('text-align','center');
		}
		if($('#toolbar .align-left-active').length > 0){
			$('#poem').css('text-align','left');
		}
		$('#poem').css('background-color',$('#background-color').val());
		$('#poem').css('border-style', $('#border-type').val());
		$('#poem').css('border-width', $('#border-size').val()+'px');
		$('#poem').css('border-color', $('#border-color').val());

		$('#poem').css('width', $('#text-width').val()+'%');
	}
	
	
	
	
	
	$('#font-family').change(function(){
		render_style();
	});
	$('#font-size').change(function(){
		render_style();
	});
	$("#font-color").miniColors({
		change: function(hex, rgb) {
			render_style();
		}
		
	});
	$('#toolbar .bold, #toolbar .bold-active').click(function(){
		if($(this).attr('class') == 'bold'){
			$(this).attr('class','bold-active');
		}else{
			$(this).attr('class','bold');
		}
		render_style();
	});
	$('#toolbar .italic, #toolbar .italic-active').click(function(){
		if($(this).attr('class') == 'italic'){
			$(this).attr('class','italic-active');
		}else{
			$(this).attr('class','italic');
		}
		render_style();
	});
	$('#toolbar .align-right, #toolbar .align-right-active').click(function(){
		if($(this).attr('class') == 'align-right'){
			$(this).attr('class','align-right-active');
			if($('#toolbar .align-center-active').length > 0){
				$('#toolbar .align-center-active').attr('class','align-center');
			}
			if($('#toolbar .align-left-active').length > 0){
				$('#toolbar .align-left-active').attr('class','align-left');
			}
			render_style();
		}
	});
	$('#toolbar .align-center, #toolbar .align-center-active').click(function(){
		if($(this).attr('class') == 'align-center'){
			$(this).attr('class','align-center-active');
			if($('#toolbar .align-right-active').length > 0){
				$('#toolbar .align-right-active').attr('class','align-right');
			}
			if($('#toolbar .align-left-active').length > 0){
				$('#toolbar .align-left-active').attr('class','align-left');
			}
			render_style();
		}
	});
	$('#toolbar .align-left, #toolbar .align-left-active').click(function(){
		if($(this).attr('class') == 'align-left'){
			$(this).attr('class','align-left-active');
			if($('#toolbar .align-center-active').length > 0){
				$('#toolbar .align-center-active').attr('class','align-center');
			}
			if($('#toolbar .align-right-active').length > 0){
				$('#toolbar .align-right-active').attr('class','align-right');
			}
			render_style();
		}
	});
	
	

	$('#toolbar .background-image').click(function(event){
		event.stopPropagation();
		if(!$('#background-box').is(':visible')){
			var position = $(this).offset();
			var width = $(this).outerWidth();
			var height = $(this).outerHeight();
			var backgroundBoxWidth = $('#background-box').outerWidth();
			$('#background-box').css({
				'left':position.left+width-backgroundBoxWidth+'px',
				'top':position.top+height+'px'
			}).show();
			if($('#background-box').offset().left < 0){
				$('#background-box').css({
					'left':'0'
				});
			}
			
			var ToTop = 0;
			$('#selImg > div').each(function(index){
				if($(this).find('div').hasClass('selected_bg')){
					ToPosition = $(this).find('div').position();
					ToTop = ToPosition.top-12;
				}
			});
			$('#selImg').scrollTop(ToTop);
			
			render_style();
		}else{
			$('#background-box').hide();
			render_style();
		}
	});
	$('#background-box').click(function(event){
		event.stopPropagation();
	});
	$(document).click(function(){
		if($('#background-box').is(':visible')){
			$('#background-box').hide();
		}
	});
	
	$("#background-color").miniColors({
		change: function(hex, rgb) {
			render_style();
		}
	});
	

	
	$('#border-type').change(function(){
		render_style();
	});
	$('#border-size').change(function(){
		render_style();
	});
	$("#border-color").miniColors({
		change: function(hex, rgb) {
			render_style();
		}
	});
	

	
	
	/*SUBMIT*/
	$('#submit').click(function(){
		
		var content = $('#poem').html();
		var result = content;

		var PoemStyle = $('#poem').attr('style');
		PoemStyle = PoemStyle.replace(/url\([^)]+\)/g, "url("+$('#return_background_image').val()+")");
		result = '[formatting="'+PoemStyle+'"]'+result+'[/formatting]';
		if(!$('#new_poem').is(':visible')){
			window.dialogArguments.text = result;
			window.returnValue = result;
			window.close();
		}else{
			var Edit_poem_id = 0;
			if($('#poems').is(':visible')){
				Edit_poem_id = $('#poems select').val();
			}
			var current_content1 = current_editor_content.substring(0, rStart[Edit_poem_id]);
			var current_content2 = current_editor_content.substring(rEnd[Edit_poem_id], current_editor_content.length);
			var all_result = current_content1 + result + current_content2;
			if($(window.dialogArguments.opener.document).find('.cke_toolbox').length){
				window.dialogArguments.opener.CKEDITOR.instances[get('e')].setData(all_result);
			}else{
				window.dialogArguments.opener.vB_Editor[get('e')].set_editor_contents(all_result);
			}
			window.close();
		}

	});
	/*\SUBMIT*/
	
	
	
	
	/*ONLOAD*/
	if($('#poem').html() == ''){
		$('#poem').html('<div></div>');
	}
	render_style();
	$('#toolbar div').each(function(){
		if (typeof $(this).attr('title') !== 'undefined' && $(this).attr('title') !== false) {
			$(this).append('<span class="title">'+$(this).attr('title')+'</span>');
			$(this).removeAttr('title');
		}
	});
	$('body').append('<div id="hint"></div>');
	$('#toolbar div').hover(
		function(){
			if($(this).find('.title').length > 0){
				var position = $(this).offset();
				var width = $(this).outerWidth();
				$('#hint').text($(this).find('.title').text());
				var hintHeight = $('#hint').outerHeight();
				var hintWidth = $('#hint').outerWidth();
				$('#hint').css({
					'left':position.left+width-hintWidth+'px',
					'top':position.top-hintHeight-3+'px'
				}).show();
			}
		},
		function(){
			if($(this).find('.title').length > 0){
				$('#hint').hide();
			}
		}
	);
	/*BACKGROUND_IMAGE*/
	var imageCount = 70;
	$('#selImg').append('<div class="none-bg" style="border:#CCCCCC solid 1px;padding:2px;cursor:pointer;overflow:hidden;text-align:center;"><div style="background-color:#D5D5D5;border:#999999 solid 1px;padding:4px;color:#666666;text-align:center;width:30px;float:right;">0</div><div style="padding:5px 10px 4px 4px;float:right;"> </div></div>');
	for (var seli = 1; seli <= imageCount; seli++) {
		$('#selImg').append('<div class="bg" style="border:#CCCCCC solid 1px;padding:2px;cursor:pointer;background-image:url(../../images/backgrounds/'+seli+'.gif)"><div style="background-color:#D5D5D5;border:#999999 solid 1px;padding:4px;color:#666666;text-align:center;width:30px;">'+seli+'</div></div>');
	}
	
	$('#selImg').children('.bg').each(function(){
		$(this).bind('click', function(){
			$('#img_url').val('');
			$('#selImg > div').css('border-color','#CCCCCC');
			$('#selImg > div').find('div').css('color','#666666');
			$('#selImg > div').find('div').removeClass('selected_bg');
			
			$(this).css('border-color','#000000');
			$(this).find('div').css('color','#000000');
			$(this).find('div').addClass('selected_bg');
			$('#poem').css('background-image','url(../../images/backgrounds/'+$(this).find('div').html()+'.gif)');
			$('#return_background_image').val('massy/images/backgrounds/'+$(this).find('div').html()+'.gif');
		});
	});
	$('#selImg .none-bg').click(function(){
		$('#img_url').val('');
		$('#selImg > div').css('border-color','#CCCCCC');
		$('#selImg > div').find('div').css('color','#666666');
		$('#selImg > div').find('div').removeClass('selected_bg');
		$(this).css('border-color','#000000');
		$(this).find('div').css('color','#000000');
		$(this).find('div').addClass('selected_bg');
		$('#poem').css('background-image','none');
		$('#return_background_image').val('');
	});
	function validateURL(textval) {
	var urlregex = new RegExp(            "^(http|https|ftp)\://([a-zA-Z0-9\.\-]+(\:[a-zA-Z0-9\.&amp;%\$\-]+)*@)*((25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])|([a-zA-Z0-9\-]+\.)*[a-zA-Z0-9\-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(\:[0-9]+)*(/($|[a-zA-Z0-9\.\,\?\'\\\+&amp;%\$#\=~_\-]+))*$");
	return urlregex.test(textval);
    }
	$('#img_url').keyup(function(){
		if(validateURL($(this).val())){
			$('#poem').css('background-image','url('+$(this).val()+')');
			$('#return_background_image').val($(this).val());
		}
	});
	/*\BACKGROUND_IMAGE*/





	/**************************************************/
	/*\ONLOAD*/
	function get(name){
		if(name=(new RegExp('[?&]'+encodeURIComponent(name)+'=([^&]*)')).exec(location.search))
		return decodeURIComponent(name[1]);
	}
	if($(window.dialogArguments.opener.document).find('.cke_toolbox').length){
		var current_editor_content = window.dialogArguments.opener.CKEDITOR.instances[get('e')].getData();

		if(window.dialogArguments.opener.CKEDITOR.env.ie)
		{
			var mySelection = window.dialogArguments.opener.CKEDITOR.instances[get('e')].getSelection();
			if(mySelection){
				mySelection.unlock(true);
				var current_text_selection = mySelection.getNative().createRange().text;
			}else{
				var current_text_selection = "";
			}
		}else{
			var current_text_selection = window.dialogArguments.opener.CKEDITOR.instances[get('e')].getSelection().getNative();
		}
	}else{
		var current_editor_content = window.dialogArguments.opener.vB_Editor[get('e')].get_editor_contents();
		var current_text_selection = window.dialogArguments.opener.vB_Editor[get('e')].get_selection();
	}
	$('#poem').html(""+current_text_selection);
	if(current_editor_content.indexOf("[formatting") == -1 && ""+current_text_selection == ''){
		alert('    ');
		window.close();
	}
	if(current_editor_content.indexOf("[formatting") != -1){
		var count_open_poem = current_editor_content.split(/\[formatting/g).length - 1;
		var count_close_poem = current_editor_content.split(/\[\/formatting\]/g).length - 1;

		if(count_open_poem != count_close_poem){
			alert('         .');
			window.close();
		}else{
			var rStyle = current_editor_content.match(/\[formatting=[^!\]]+\]/g);
			rStart = new Array();
			for(i=0; i<=rStyle.length-1; i++){
				rStart[i] = current_editor_content.indexOf(rStyle[i]);
				rStyle[i] = replaceAll(rStyle[i], '\\[formatting=\"','');
				rStyle[i] = replaceAll(rStyle[i], '\\"]','');
				rStyle[i] = replaceAll(rStyle[i], 'massy\/images\/backgrounds\/','../../images/backgrounds/');
				
			}
			var rContent = current_editor_content.match(/(\[formatting=[^\]]+\])([^*](?!\[formatting))+(\[\/formatting\])/g);
			rEnd = new Array();
			for(i=0; i<=rContent.length-1; i++){
				rEnd[i] = current_editor_content.indexOf(rContent[i]) + rContent[i].length;
				rContent[i] = rContent[i].replace(/\[formatting=[^!\]]+\]/g, '');
				rContent[i] = rContent[i].replace(/\[\/formatting]/g, '');
			}
			
			var Append = '';
			for(i=0; i<=rStyle.length-1; i++){
				Append = $('<div id="current_poem_'+i+'" style="'+rStyle[i]+'">'+rContent[i]+'</div>');
				$('body').append(Append);
				Append.hide();
			}
			$('#poem').html($('#current_poem_0').html());
			$('#poem').attr('style', $('#current_poem_0').attr('style'));
			$('#poem').show();
			if(rStyle.length > 1){
				for(i=0; i<=rStyle.length-1; i++){
					 $('#poems select').append('<option value="'+i+'">  '+(parseInt(i)+1)+'</option>');
				}
				$('#poems').show();
			}
			$('#poems select').live('change',function(){
				$('#poem').html($('#current_poem_'+$(this).val()).html());
				$('#poem').attr('style', $('#current_poem_'+$(this).val()).attr('style'));
				$('#poem').show();
				Rebuild_toolbar();
			});
			if(rStyle.length >= 1){
				$('#header div#new_poem').show();
			}
			$('#header div#new_poem a').live('click', function(){
				return false;
			});
			$('#header div#edit_poem a').live('click', function(){
				$('#header div#edit_poem').hide();
				$('#header div#new_poem').show();
				if(rStyle.length > 1){
					$('#poems').show();
				}
				$('#poems select').val(0);
				$('#poem').html($('#current_poem_0').html());
				$('#poem').attr('style', $('#current_poem_0').attr('style'));
				$('#poem').show();
				Rebuild_toolbar();
				return false;
			});


			/*****OPEN NEW****/
			if(""+current_text_selection != ""){
				$('#poems').hide();
				$('#header div#new_poem').hide();
				if(rStyle.length >= 1){
					$('#header div#edit_poem').show();
				}
				$('#poem').html('<div></div>');
				$('#poem').attr('style', '');
				$('#poem').html(""+current_text_selection);
				$('#poem').show();
				Reset_toolbar();
			}
			/*****OPEN NEW****/


/**************************************************/

			function Reset_toolbar(){
				$('#font-family').val('Arial');
				$('#font-size').val('13');
				$('#font-color').val('#000000');
				$('#font-color').next('.miniColors-trigger:first').css('background-color', '#000000');
				if($('#toolbar .bold-active').length > 0){
					$('#toolbar .bold-active').attr('class','bold');
				}
				if($('#toolbar .italic-active').length > 0){
					$('#toolbar .italic-active').attr('class','italic');
				}
				if($('#toolbar .align-right').length > 0){
					$('#toolbar .align-right').attr('class','align-right-active');
				}
				if($('#toolbar .align-left-active').length > 0){
					$('#toolbar .align-left-active').attr('class','align-left');
				}
				if($('#toolbar .align-center-active').length > 0){
					$('#toolbar .align-center-active').attr('class','align-center');
				}
				$('#return_background_image').val('');
				$('#img_url').val('');
				$('#selImg').children('.bg').each(function(){
					$(this).css('border-color','#CCCCCC');
					$(this).find('div').css('color','#666666');
					$(this).find('div').removeClass('selected_bg');
				});
				$('#selImg .none-bg').css('border-color','#000000');
				$('#selImg .none-bg').find('div').css('color','#000000');
				$('#selImg .none-bg').find('div').addClass('selected_bg');
				
				$('#background-color').val('#FFFFFF');
				$('#background-color').next('.miniColors-trigger:first').css('background-color', '#FFFFFF');
				

				
				$('#border-type').val('none');
				$('#border-size').val('1');
				$('#border-color').val('#000000');
				$('#text-width').val('100');
				render_style();
			}
			
			/******************************************************/
			function Rebuild_toolbar(){
				if($('#poem').css('font-family').length > 0){
					$('#font-family').val($('#poem').css('font-family'));
				}
				if($('#poem').css('font-size').length > 0){
					$('#font-size').val($('#poem').css('font-size').replace('px',''));
				}
				if($('#poem').css('color').length > 0){
					$('#font-color').val(colorToHex($('#poem').css('color')));
					$('#font-color').next('.miniColors-trigger:first').css('background-color', colorToHex($('#poem').css('color')));
				}
				if($('#poem').css('font-weight').length > 0){
					if($('#poem').css('font-weight') == 'bold' || $('#poem').css('font-weight') == '700'){
						$('#toolbar .bold').attr('class','bold-active');
					}
				}
				if($('#poem').css('font-style').length > 0){
					if($('#poem').css('font-style') == 'italic'){
						$('#toolbar .italic').attr('class','italic-active');
					}
				}
				if($('#poem').css('text-align').length > 0){
					if($('#toolbar .align-right-active').length > 0){
						$('#toolbar .align-right-active').attr('class','align-right');
						$('#toolbar .align-left-active').attr('class','align-left');
						$('#toolbar .align-center-active').attr('class','align-center');
						if($('#poem').css('text-align') == 'left'){
							$('#toolbar .align-left').attr('class','align-left-active');
						}else if($('#poem').css('text-align') == 'center'){
							$('#toolbar .align-center').attr('class','align-center-active');
						}else{
							$('#toolbar .align-right').attr('class','align-right-active');
						}
					}
				}
				
				

				if($('#poem').css('background-image').length > 0){
					if($('#poem').css('background-image') != 'none'){
						var BackgroundValue = $('#poem').css('background-image').replace('url(','');
						BackgroundValue = BackgroundValue.replace(')','');
						BackgroundValue = BackgroundValue.replace("'","");
						BackgroundValue = BackgroundValue.replace('"','');
						var cLocation = location.href.split('massy/poem/')[0];
						if(BackgroundValue.substring(0, cLocation.length) == cLocation){
							BackgroundValue = BackgroundValue.split(cLocation)[1];
						}
						$('#return_background_image').val(BackgroundValue);
						if(BackgroundValue.substring(0,5) == 'http:'){
							$('#img_url').val(BackgroundValue);
						}else{
							var findBG = BackgroundValue.replace('massy/images/backgrounds/','');
							findBG = findBG.replace('.gif','');
							$('#selImg').children('.bg').each(function(){
								if($(this).find('div').text() == findBG){
									$(this).css('border-color','#000000');
									$(this).find('div').css('color','#000000');
									$(this).find('div').addClass('selected_bg');
								}else{
									$(this).css('border-color','#CCCCCC');
									$(this).find('div').css('color','#666666');
									$(this).find('div').removeClass('selected_bg');
								}
							});
							$('#selImg .none-bg').css('border-color','#CCCCCC');
							$('#selImg .none-bg').find('div').css('color','#666666');
							$('#selImg .none-bg').find('div').removeClass('selected_bg');
						}
					}else{
						$('#selImg .none-bg').css('border-color','#000000');
						$('#selImg .none-bg').find('div').css('color','#000000');
						$('#selImg .none-bg').find('div').addClass('selected_bg');
					}
				}else{
					$('#selImg .none-bg').css('border-color','#000000');
					$('#selImg .none-bg').find('div').css('color','#000000');
					$('#selImg .none-bg').find('div').addClass('selected_bg');
				}
				
				if($('#poem').css('background-color').length > 0){
					$('#background-color').val(colorToHex($('#poem').css('background-color')));
					$('#background-color').next('.miniColors-trigger:first').css('background-color', colorToHex($('#poem').css('background-color')));
				}
				

				
				
				if($('#poem').css('border-style').length > 0){
					$('#border-type').val($('#poem').css('border-style'));
				}else{
					if($('#poem').css('border-left-style').length > 0){
						$('#border-type').val($('#poem').css('border-left-style'));
					}
				}
				if($('#poem').css('border-width').length > 0){
					$('#border-size').val($('#poem').css('border-width').replace('px',''));
				}else{
					if($('#poem').css('border-left-width').length > 0){
						$('#border-size').val($('#poem').css('border-left-width').replace('px',''));
					}
				}
				if($('#poem').css('border-color').length > 0){
					$('#border-color').val(colorToHex($('#poem').css('border-color')));
					$('#border-color').next('.miniColors-trigger:first').css('background-color', colorToHex($('#poem').css('border-color')));
				}else{
					if($('#poem').css('border-left-color').length > 0){
						$('#border-color').val(colorToHex($('#poem').css('border-left-color')));
						$('#border-color').next('.miniColors-trigger:first').css('background-color', colorToHex($('#poem').css('border-left-color')));
					}
				}


			   /*	if($('#poem').css('width').length > 0){
				   alert($('#poem')[0].style.width.replace('%',''));
					$('#text-width').val($('#poem')[0].style.width.replace('%',''));
					var MyWidth = $('#text-width').val();

				   alert($('#text-width').val());
					$('#poem').css('width', $('#text-width').val()+'%');
					$('#text-width').range({
						range:false,
						set: MyWidth,
						blur:function(){
							$('#poem').css('width', $('#text-width').val()+'%');
						}
					});
					alert($('#text-width').val());
				}*/
			}
			Rebuild_toolbar();
		}
	}
	
	







	

});